<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on September 15, 2009 at 11:47:20 am</time-stamp>
<!-- Changes from: PV-DM-Support(Green.25,bbuxton)  to: PV-DM-Support(Green.26,carry) -->


<methods>
<class-id>PROVISO.PvSubelementGroup class</class-id> <category>utility</category>

<body package="PV-DM-Support" selector="selectStatementForGroupItemRelationshipsForElementsWhichMovedInForCollectors:inHourBefore:">selectStatementForGroupItemRelationshipsForElementsWhichMovedInForCollectors: collectors
	inHourBefore: boundarySeconds

	"self dbSession execute: 
		(self 
			selectStatementForGroupItemRelationshipsForElementsWhichMovedInForCollectors: #(50)
			inHourBefore: (PvTimestamp fromString: '2002.07.24-21.00.00') asSeconds)"

	| namedReplacements |
	namedReplacements := Dictionary new.
	namedReplacements at: 'TABLE' put: self historyGroupItemRelationshipTable asString.
	namedReplacements at: 'ELEMENTHISTORYTABLE' put: PvElement historyTableName asString.
	namedReplacements at: 'SUBELEMENTHISTORYTABLE' put: PvSubelement historyTableName asString.
	namedReplacements at: 'COLUMNLIST' put: ' t1.idx_group, t1.idx_alias_inst, t1.str_action  '.
	namedReplacements at: 'ENDOFHOURDATECONDITION' put: boundarySeconds asString, ' '.
	namedReplacements at: 'STARTOFHOURDATECONDITION' put: (boundarySeconds - 3600) asString, ' '.
	namedReplacements at: 'COLLECTORLIST' put: (self inStatementForCollectors: collectors) asString.

^'SELECT /*+ ORDERED NO_MERGE(VIEW2) USE_NL(VIEW2 t1) */ t1.idx_group,
       t1.idx_alias_inst,
       t1.str_action
  FROM (SELECT /*+ ORDERED NO_MERGE(VIEW1) USE_NL(eVIEW se1) */ se1.idx_ind
          FROM (SELECT /*+ NO_MERGE(VIEW1) PUSH_SUBQ ORDERED */ E.idx_ind,
                       E.dte_date
                  FROM elmt_desc_hist E,
                       (SELECT /*+ push_subq */ el1.IDX_IND
                          FROM elmt_desc_hist el1
                         WHERE el1.int_collector NOT IN %COLLECTORLIST
                           AND el1.dte_date = (SELECT MAX(el2.dte_date)
                                                 FROM elmt_desc_hist el2
                                                WHERE el2.dte_date &lt; %STARTOFHOURDATECONDITION
                                                  AND el2.idx_ind = el1.idx_ind)
                           AND el1.dte_date &lt; %STARTOFHOURDATECONDITION
                           AND el1.str_action IN (''I'', ''U'')) VIEW1
                 WHERE view1.idx_ind = E.idx_ind
                   AND E.DTE_DATE = (SELECT MAX(E2.DTE_DATE)
                                       FROM elmt_desc_hist E2
                                      WHERE E2.IDX_IND = E.IDX_IND
                                        AND E2.DTE_DATE &lt;= %ENDOFHOURDATECONDITION
                                        AND E.INT_COLLECTOR IN %COLLECTORLIST)
                   AND E.dte_date between %STARTOFHOURDATECONDITION and %ENDOFHOURDATECONDITION
                   AND E.STR_ACTION IN (''U'')) eView,
                       se_desc_hist se1
                 WHERE eView.idx_ind = se1.idx_host
                   AND se1.DTE_DATE = (SELECT MAX(se2.DTE_DATE)
                                         FROM se_desc_hist se2
                                        WHERE se2.idx_ind = se1.idx_ind
						AND se2.idx_host = se1.idx_host
                                      		AND se2.dte_date &lt;= %ENDOFHOURDATECONDITION)) VIEW2,
                       se_grp_member_hist t1
                 WHERE VIEW2.idx_ind = t1.idx_alias_inst
                   AND t1.DTE_DATE = (SELECT MAX(t2.DTE_DATE)
                                        FROM se_grp_member_hist t2
                                       WHERE t1.idx_alias_inst = t2.idx_alias_inst
                                         AND t1.idx_group = t2.idx_group
                                         AND t2.dte_date &lt;= %ENDOFHOURDATECONDITION)
                   AND t1.dte_date &lt;= %ENDOFHOURDATECONDITION'
	namedBindWithArguments: namedReplacements</body>
</methods>


<methods>
<class-id>PROVISO.PvBaseSubelement class</class-id> <category>database support</category>

<body package="PV-DM-Support" selector="selectStatementForElementsWhichMovedInForCollectors:inHourBefore:">selectStatementForElementsWhichMovedInForCollectors: collectors
	inHourBefore: boundarySeconds

	"self dbSession execute: 
		(self 
			selectStatementForElementsWhichMovedInForCollectors: #(50)
			inHourBefore: (PvTimestamp fromString: '2002.07.24-21.00.00') asSeconds)"


	| namedReplacements |
	namedReplacements := Dictionary new.
	namedReplacements at: 'TABLE' put: self historyTableName asString.
	namedReplacements at: 'ELEMENTHISTORYTABLE' put: PvElement historyTableName asString.
	namedReplacements at: 'ENDOFHOURDATECONDITION' put: boundarySeconds asString, ' '.
	namedReplacements at: 'STARTOFHOURDATECONDITION' put: (boundarySeconds - 3600) asString, ' '.
	namedReplacements at: 'COLUMNLIST' put: (self allHistoricalColumnsForSelectWithPrefix: 't1.').
	namedReplacements at: 'COLLECTORLIST' put: (self inStatementForCollectors: collectors) asString.


^'SELECT /*+ ORDERED NO_MERGE(eView) USE_NL(eView t1)  */
		%COLUMNLIST 
  FROM (SELECT /*+ NO_MERGE(VIEW1) PUSH_SUBQ ORDERED */
	      	E.idx_ind, E.dte_date
		FROM elmt_desc_hist E,
			( SELECT /*+ push_subq */
				el1.IDX_IND
			FROM elmt_desc_hist el1
			WHERE el1.int_collector NOT IN %COLLECTORLIST
				AND el1.dte_date = ( SELECT MAX(el2.dte_date)
					FROM elmt_desc_hist el2
					WHERE el2.dte_date  &lt; %STARTOFHOURDATECONDITION
						AND el2.idx_ind = el1.idx_ind )
			AND el1.dte_date  &lt; %STARTOFHOURDATECONDITION
			AND el1.str_action IN (''I'',''U'') ) VIEW1
		WHERE view1.idx_ind = E.idx_ind
			AND E.DTE_DATE = ( SELECT MAX( E2.DTE_DATE )
						FROM elmt_desc_hist E2
						WHERE E2.IDX_IND = E.IDX_IND
							AND E2.DTE_DATE  &lt;= %ENDOFHOURDATECONDITION
							AND E.INT_COLLECTOR IN %COLLECTORLIST)
			AND E.dte_date  between %STARTOFHOURDATECONDITION and  %ENDOFHOURDATECONDITION
			AND E.STR_ACTION IN (''U'') ) eView,
		se_desc_hist t1
	WHERE eView.idx_ind = t1.idx_host
		AND t1.dte_date = ( SELECT  MAX(se1.dte_date)
						FROM se_desc_hist se1
						WHERE se1.idx_ind = t1.idx_ind
							AND se1.idx_host = t1.idx_host
							AND se1.dte_date  &lt;= %ENDOFHOURDATECONDITION )
        AND t1.dte_date  &lt;= %ENDOFHOURDATECONDITION'
	namedBindWithArguments: namedReplacements</body>
</methods>



</st-source>
